function RUNME()

repeat = 2;
ns = unique(ceil(exp(log(100):0.1:log(1000000))));

max_time = 0.6;

maxrelres = 1e-5;

time_abgabe  = zeros(1, length(ns));
time_lapack  = zeros(1, length(ns));
time_matlabqr= zeros(1, length(ns));
res_abgabe   = zeros(1, length(ns));
max_res      = zeros(1, length(ns));

do_matlab_qr = true;

act_pos = 0;

disp('Vergleiche Geschwindigkeiten');
fprintf('\n');
disp('mit Matlab QR');

count = 0;

for i=1:length(ns)
   act_pos = act_pos+1;

   n = ns(i);

   fprintf('%d|', n);
   count = count+1;
   if( count>15 )
      fprintf('\n');
      count = 0;
   end

   sumtime_abgabe  = 0;
   sumtime_lapack  = 0;
   sumtime_matlabqr= 0;
   sumres_abgabe   = 0;
   sumres_matlabqr = 0;
   summax_res      = 0;

   for j=1:repeat

      m = 10;
      A = randn(n, m);
      b = randn(n, 1);

      % run Abgabe
      tic;
      [x_abgabe, other_res] = ausgleichsproblem(A, b);
      sumtime_abgabe = sumtime_abgabe + toc;

      % run LAPACK
      tic;
      x_lapack = A\b;
      sumtime_lapack = sumtime_lapack + toc;

      if( do_matlab_qr )
         % run MATLAB QR
         tic;
         [Q,R] = qr(A);
         Qb = Q'*b;
         x_matlab = R(1:m,1:m)\Qb(1:m);
         sumtime_matlabqr = sumtime_matlabqr + toc;
      end

      maxres = m*100*eps;

      resid = norm(x_abgabe - x_lapack);

      if( resid > maxres )
         resid
         maxres
         error('Fehler! Benutzen Sie erst mal die Datei TEST.m um die Korrektheit ihrer Aufgabe zu pruefen!');
      end

      sumres_abgabe = sumres_abgabe + resid;

      summax_res = summax_res + maxres;

   end

   time_abgabe(i)   = sumtime_abgabe/repeat;
   time_lapack(i)   = sumtime_lapack/repeat;
   time_matlabqr(i) = sumtime_matlabqr/repeat;
   res_abgabe(i)    = sumres_abgabe/repeat;
   max_res(i)       = summax_res/repeat;

   if( sumtime_matlabqr > max_time )
      do_matlab_qr = false;
      fprintf('\n\n');
      count = 0;
      disp('ohne Matlab QR');
   end

   if( (sumtime_abgabe+sumtime_lapack)>max_time )
      break;
   end
end

fprintf('\n');

time_abgabe   = time_abgabe(2:act_pos);
time_lapack   = time_lapack(2:act_pos);
time_matlabqr = time_matlabqr(2:act_pos);
res_abgabe    = res_abgabe(2:act_pos);
max_res       = max_res(2:act_pos);
ns = ns(2:act_pos);

subplot(2,1,1);
loglog(ns, time_abgabe, 'b-', ns, time_lapack, 'r--', ns, time_matlabqr, 'k-.');
title('Loesung des linearen Ausgleichsproblems: min ||Ax-b||');
xlabel('n = Anzahl der Zeilen in A');
ylabel('Laufzeit');
legend('Abgabe', 'LAPACK', 'via Matlab QR', 'Location', 'SouthEast');

subplot(2,1,2);
loglog(ns, res_abgabe, 'b-' );
hold on;
loglog(ns, max_res, 'r-' )
xlabel('n = Anzahl der Zeilen in A');
legend('|| x_{abgabe} - x_{lapack} ||', 'Maximal erlaubtest Residuum', 'Location', 'NorthWest');

hold off;

