function TEST()


repeat = 5;
max_n = 100;

%
% ................. house.m
%
disp('Teste house.m ...');

for n=1:max_n
   for i=1:repeat
      x = randn(n,1);
      [beta, v] = house(x);

      H = eye(n) - beta * v * v';

      Hx = H*x;

      err1 = norm( Hx(2:end) );
      err2 = abs( abs(Hx(1))-norm(x) );

      if( err1 > n*100*eps || err2 > n*100*eps )
         x
         v
         beta
         error('Die Datei house.m scheint nicht richtig zu arbeiten!');
      end
   end
end

disp('OK');


%
% ................. h_anwenden.m
%
disp('Teste h_anwenden.m ...');

for n=1:max_n
   for i=1:repeat
      x = randn(n,1);
      [beta, v] = house(x);

      X = randn(n,i);

      H = eye(n) - beta * v * v';
      Y_echt = H*X;

      Y = h_anwenden(v, beta, X);

      err = norm( Y_echt-Y );

      if( err > n*i*100*eps )
         v
         beta
         X
         Y
         error('Die Datei house.m scheint nicht richtig zu arbeiten!');
      end
   end
end

disp('OK');

%
% ................. qr_zerlegung.m und q_anwenden.m
%
disp('Teste qr_zerlegung.m und q_andwenden.m ...');

for n=1:max_n
   for i=1:repeat
      A = randn(n, 2*i);
      [QR, betas] = qr_zerlegung(A);

      if( i==1 )
         cols = 1;
      elseif( i==repeat )
         cols = n;
      else
         cols = 2*i;
      end

      MAT = randn(n, cols);

      Q = q_anwenden(QR, betas, eye(n), false);
      QT = q_anwenden(QR, betas, eye(n), true);
      QMAT = q_anwenden(QR, betas, MAT, false);
      QTMAT = q_anwenden(QR, betas, MAT, true);

      R = triu(QR);

      err1 = norm(Q'-QT);
      err2 = norm(Q*QT-eye(n));
      err3 = norm(QT*QMAT - MAT);
      err4 = norm(Q*QTMAT - MAT);
      err5 = norm(Q*R - A);

      loctol = n*2*i*100*eps;

      if( err1>loctol || err2>loctol || err3>loctol || ...
                         err4>loctol || err5>loctol )
         A
         QR
         MAT
         Q
         QT'
         R
         error('Die Datei qr_zerlegung.m im Zusammenspiel mit q_anwenden scheint nicht richtig zu funktionieren!');
      end
   end
end

disp('OK');

%
% ................. ausgleichsproblem.m
%
disp('Teste ausgleichsproblem.m ...');

for n=1:max_n
   for i=1:repeat
      A = randn(n+2*i, 2*i);
      b = randn(n+2*i, 1);
      [x_studi, res_studi] = ausgleichsproblem(A, b);

      x_echt = A\b;
      res_echt = norm(A*x_echt - b);

      loctol = (n+2*i)*(2*i)*1000*eps;

      err1 = norm(x_echt-x_studi);
      err2 = norm(res_echt-res_studi);

      if( err1>loctol || err2>loctol )
         A
         b
         error('Die Datei ausgleichsproblem.m scheint nicht richtig zu funktionieren!');
      end
   end
end

disp('OK');

disp('Alles scheint zu funktionieren');
